#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define VPCALC_SECTION	"DEV"
#define VPCALC_SUBSECT	"LINK"

#include "../config.h"
#include "../include/types.h"
#include "../include/debug.h"

#include "linkport.h"

typedef enum {
	TYPE_DEAD,
} linkport_type;

typedef struct _linkport_o {
	linkport_type type;

	uint8 link;
} _linkport_o;

linkport_o linkport_new(const char *type)
{
	_linkport_o *new;

	new = (_linkport_o *)malloc(sizeof(_linkport_o));
	if (new != NULL) {
		memset(new, 0, sizeof(_linkport_o));

		if (!strcmp(type, "dead")) {
			new->type = TYPE_DEAD;
		} else {
			_err_report("Unknown linkport type!");
			free(new);
			return NULL;
		}
	}

	return (linkport_o)new;
}

void linkport_del(linkport_o linkport)
{
	_linkport_o *_linkport = (_linkport_o *)linkport;

	free(_linkport);
}

void linkport_update(linkport_o linkport, uint8 val)
{
	_linkport_o *_linkport = (_linkport_o *)linkport;
	uint8 link;

	if (_linkport->type == TYPE_DEAD) {
		link = ( (_linkport->link & 0x3c) | /* save 00111100 of link */
		       (((_linkport->link & 0x0c) >> 2) ^ 0x03) );
	}

	_linkport->link = link;
}

uint8 linkport_status(linkport_o linkport)
{
	_linkport_o *_linkport = (_linkport_o *)linkport;

	if (_linkport->type == TYPE_DEAD) {
		/* nothing to do, to update the value. */
	}

	return _linkport->link;
}
