#ifndef __VPCALC_CALC_H
#define __VPCALC_CALC_H

#include <SDL_keysym.h>

typedef void *calc_o;

calc_o calc_new(config_o conf, timing_func callback);
void calc_del(calc_o calc);

uint8 calc_read(calc_o calc, unsigned int addr);
void calc_write(calc_o calc, unsigned int addr, uint8 data);

size_t calc_size(calc_o calc);
void calc_putimage(calc_o calc, void *data);
unsigned char *calc_getimage(calc_o calc, int *size);

void calc_update(calc_o calc);
void calc_draw(calc_o calc);
void calc_palette(calc_o calc, int i, uint8 r, uint8 g, uint8 b);

void calc_keydown(calc_o calc, SDLKey key);
void calc_keyup(calc_o calc, SDLKey key);

int calc_execute(calc_o calc);
void calc_terminate(calc_o calc);

int calc_cycle(calc_o calc);
void calc_interrupt(calc_o calc, unsigned int data);

void calc_report(calc_o calc, FILE *out);
void calc_alter(calc_o calc, const char *regname, unsigned int value);

#endif 
