#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include "../config.h"
#include "../include/types.h"
#include "../include/debug.h"

int debug_err(const char *section, const char *subsect, const char *msg, ...)
{
	va_list ap;
	int ret;

	va_start(ap, msg);
	ret = fprintf(stderr, "!!! [%s/%s] error: ", section, subsect);
	ret += vfprintf(stderr, msg, ap);
	ret += fprintf(stderr, "\n");
	va_end(ap);

	return ret;
}

int debug_warn(const char *section, const char *subsect, const char *msg, ...)
{
	va_list ap;
	int ret;

	va_start(ap, msg);
	ret = fprintf(stderr, "*** [%s/%s] warning: ", section, subsect);
	ret += vfprintf(stderr, msg, ap);
	ret += fprintf(stderr, "\n");
	va_end(ap);

	return ret;
}

int debug_report(const char *section, const char *subsect, const char *msg, ...)
{
	va_list ap;
	int ret;

	va_start(ap, msg);
	ret = fprintf(stderr, "[%s/%s] ", section, subsect);
	ret += vfprintf(stderr, msg, ap);
	ret += fprintf(stderr, "\n");
	va_end(ap);

	return ret;
}

